<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item label="角色名称" prop="roleName">
        <el-input
          v-model="queryParams.roleName"
          placeholder="请输入角色名称"
          clearable
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">
          搜索
        </el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd">
          新增角色
        </el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="pageList" border>
      <el-table-column
        align="center"
        label="序号"
        type="index"
        :index="(index) => (queryParams.pageNum - 1) * queryParams.pageSize + index + 1"
        width="120"
      />
      <el-table-column align="center" label="角色ID" prop="id" :show-overflow-tooltip="true" />
      <el-table-column
        align="center"
        label="角色名称"
        prop="roleName"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="创建时间"
        prop="createTime"
        :show-overflow-tooltip="true"
      />
      <el-table-column
        align="center"
        label="创建人"
        prop="createBy"
        :show-overflow-tooltip="true"
      />
      <el-table-column align="center" label="状态" prop="status" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          {{ ROLE_STATUS.getLabelByValue(scope.row.status) }}
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        label="操作"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button size="mini" type="text" @click="handleSwitchEnable(scope.row)">
            {{ scope.row.status === ROLE_STATUS.getValueByName('enabled') ? "停用" : "启用" }}
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleEdit(scope.row)"
            :disabled="scope.row.status === ROLE_STATUS.getValueByName('enabled')"
          >
            编辑
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleDelete(scope.row)"
            :disabled="scope.row.status === ROLE_STATUS.getValueByName('enabled')"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <CrudPopup ref="crud" />
  </div>
</template>

<script>
import ApiButton from "@/components/ApiButton/index.vue";
import { rolePageList, disableRole, enableRole, delRole } from "@/api/userManage/role";
import CrudPopup from "./components/CrudPopup/index.vue";
import { ROLE_STATUS } from '@/enums/index';
export default {
  name: "RoleManage",
  components: {
    ApiButton,
    CrudPopup,
  },
  data() {
    return {
      ROLE_STATUS,
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        roleName: "",
      },
      pageList: [],
    };
  },
  created() {
    this.loadData();
  },
  activated() {
    this.loadData();
  },
  methods: {
    loadData() {
      this.getList();
    },
    /** 查询角色列表 */
    getList() {
      this.loading = true;
      rolePageList(this.queryParams)
        .then((res) => {
          const { data: { list, page } } = res
          this.pageList = list || [];
          this.total = page?.total || 0;
        })
        .finally(() => {
          this.loading = false;
        });
    },

    // 表单重置
    reset() {
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增 */
    handleAdd() {
      this.$refs.crud.open({}).then(this.getList);
    },

    /** 编辑 */
    handleEdit(item) {
      this.$router.push({ name: "RoleDetail", params: { id: item.id } });
    },

    /** 启用/禁用切换 */
    handleSwitchEnable(item) {
      const isEnable = item.status === this.ROLE_STATUS.getValueByName('enabled');
      const fetch = async () => {
        if (isEnable) {
          await disableRole(item.id);
        } else {
          await enableRole(item.id);
        }
        this.$message.success("操作成功");
        this.getList();
      };
      if (isEnable) {
        this.$modal
          .confirm(`是否确认停用？`)
          .then(fetch)
          .catch(() => {});
      } else {
        fetch();
      }
    },
    handleDelete(item) {
      this.$modal
        .confirm("是否确认删除？")
        .then(async () => {
          await delRole(item.id);
          this.$message.success("操作成功");
          this.getList();
        })
        .catch(() => {});
    },
  },
};
</script>
<style lang="scss" scoped></style>
